### Method

# Gio Socket send_with_blocking

since: 2.26

#### Declaration

    gssize
    g_socket_send_with_blocking (
      GSocket* socket,
      const gchar* buffer,
      gsize size,
      gboolean blocking,
      GCancellable* cancellable,
      GError** error
    )

#### Description

This behaves exactly the same as g_socket_send(), except that the choice of blocking or non-blocking behavior is determined by the `blocking` argument rather than by `socket`‘s properties.

Available since: 2.26

#### Parameters

`buffer`

  Type: An array of `guint8`

  The buffer containing the data to send.

  The length of the array is specified in the `size` argument.
  The data is owned by the caller of the method.

`size`

  Type: `gsize`

  The number of bytes to send.

`blocking`

  Type: `gboolean`

  Whether to do blocking or non-blocking I/O.

`cancellable`

  Type: `GCancellable`

  A %GCancellable or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gssize`

Number of bytes written (which may be less than `size`), or -1 on error.